*ASM                                                                            
         TITLE 'RAHWBANL'                                           '           
* ====================================================================          
* =                                                                  =          
* =    RAHWBANL: RAH Web SupportPac Analyser Program                 =          
* =                                                                  =          
* =                                                                  =          
* =    RAHWBANL is a CICS/Web Analyser for CICS TS/390 1.2.          =          
* =                                                                  =          
* =             It permits the specification of analyser output      =          
* =             fields via settings in the URL.                      =          
* =                                                                  =          
* =             See SC33-1944 CICS Internet and External Interfaces  =          
* =                           Guide for details about analysers.     =          
* =                                                                  =          
* =                                                                  =          
* =                                                                  =          
* =                                                                  =          
* =    Register Usage :                                              =          
* =    ================                                              =          
* =                                                                  =          
* =        R0   ->                                                   =          
* =        R1   ->                                                   =          
* =        R2   ->                                                   =          
* =        R3   ->                                                   =          
* =        R4   ->                                                   =          
* =        R5   -> Linkage Register                                  =          
* =        R6   -> Base 1                                            =          
* =        R7   -> Base 2                                            =          
* =        R8   -> Base 3                                            =          
* =        R9   -> DFHEISTG                                          =          
* =        R10  -> DFHEISTG                                          =          
* =        R11  -> EIB                                               =          
* =        R12  -> TCA                                               =          
* =        R13  -> CSA                                               =          
* =        R14  ->                                                   =          
* =        R15  ->                                                   =          
* =                                                                  =          
* =                                                                  =          
* =                                                                  =          
* =                                                                  =          
* =    Note                                                          =          
* =    ====                                                          =          
* =                                                                  =          
* =    The Unescape setting (WBRA_UNESCAPE) requires the 'Unescape'  =          
* =    fix to be applied. Therefore, conditional assembly is used    =          
* =    to avoid setting a non-existant field and direct usage is     =          
* =    made of WBRA_UNESCAPE_REQUIRED and WBRA_UNESCAPE_NOT_REQUIRED.=          
* =                                                                  =          
* =                                                                  =          
* =    Applying the Unescape fix will require recompilation of this  =          
* =    analyser to pick up the correct commarea length.              =          
* =                                                                  =          
* =                                                                  =          
* =    Copyright and Support                                         =          
* =    =====================                                         =          
* =                                                                  =          
* =    This program is not supported by any way by IBM. It is        =          
* =    distributed only to show techniques for CICS usage. It may    =          
* =    be freely modified and adapted by your installation.          =          
* =                                                                  =          
* =                                                                  =          
* =    Author:   Robert Harris,                                      =          
* =              CBSeries Design,                                    =          
* =              IBM Hursley Park,                                   =          
* =              England.                                            =          
* =                                                                  =          
* =                                                                  =          
* =    (C) Copyright IBM UK Limited, 1998.                           =          
* =                                                                  =          
* =    Licensed Materials - Property of IBM                          =          
* =    SupportPac CA86                                               =          
* =    US Government Users Restricted Rights - Use, duplication or   =          
* =    disclosure restricted by GSA ADP Schedule Contract with IBM   =          
* =    Corp.                                                         =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =                General declarations                              =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
R0       EQU   0                                                                
R1       EQU   1                                                                
R2       EQU   2                                                                
R3       EQU   3                                                                
R4       EQU   4                                                                
R5       EQU   5                                                                
R6       EQU   6                                                                
R7       EQU   7                                                                
R8       EQU   8                                                                
R9       EQU   9                                                                
R10      EQU   10                                                               
R11      EQU   11                                                               
R12      EQU   12                                                               
R13      EQU   13                                                               
R14      EQU   14                                                               
R15      EQU   15                                                               
RA       EQU   10                                                               
RB       EQU   11                                                               
RC       EQU   12                                                               
RD       EQU   13                                                               
RE       EQU   14                                                               
RF       EQU   15                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =                Analyser Dsects                                   =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         COPY  DFHWBTDD                     Analyser commarea                   
         SPACE 2                                                                
         COPY  DFHWBUCD                     Analyser definitions                
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =                KeySet Dsect                                      =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
KEYSETDS DSECT                              Map KeySet Table                    
         SPACE 2                                                                
KSNA     DS    CL8                          Name of Keyset                      
KSTE     DS    CL4                          Terminal                            
KSTR     DS    CL4                          Transaction                         
KSCV     DS    CL8                          Converter program                   
KSCP     DS    CL8                          Conversion Key                      
KSPR     DS    CL8                          Server Program                      
KSUI     DS    CL8                          UserId                              
KSUT     DS    CL8                          User Token                          
KSUE     DS    CL1                          Unescape (Y|N)                      
         SPACE 2                                                                
KSLEN    EQU   *-KSNA                       Length of element                   
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =                Variables                                         =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
DFHEISTG DSECT                                                                  
         SPACE 2                                                                
* ===> Start of User defined Variables <===                                     
         SPACE 2                                                                
EISSTART DS    0H                           Start of EIS                        
         SPACE 2                                                                
EIBSAVE  DS    F                            Save of EIB Register                
         SPACE 2                                                                
CAP      DS    AL4                          Commarea Pointer                    
CAL      DS    F                                     Length                     
CALH     DS    H                                                                
         SPACE 2                                                                
UTERMID  DS    CL4                          Requested Termid                    
UTRANID  DS    CL4                                    Transid                   
UCONVER  DS    CL8                                    Converter                 
UCONVCP  DS    CL8                                    Conversion                
UPROGER  DS    CL8                                    Program                   
UUSERID  DS    CL8                                    Userid                    
UUTOKEN  DS    CL8                                    UserToken                 
UUUNESC  DS    XL1                                    UnEscape                  
         DS    XL3                                                              
URC      DS    F                                      RC                        
UAC      DS    F                                      AC                        
         SPACE 2                                                                
CAACT    DS    CL8                          Commarea action                     
         SPACE 2                                                                
SAVECOMM DS    XL200                        Commarea on entry                   
COMMAREA DS    XL200                        Commarea used                       
         SPACE 2                                                                
URLL     DS    F                            /url/ area length                   
MAXURL   DS    F                                       max length               
URL      DS    CL200                                   data                     
         SPACE 2                                                                
RESP     DS    F                            EIB RC                              
RESP2    DS    F                                AC                              
         SPACE 2                                                                
KEY      DS    CL3                          Key=Value areas                     
         DS    XL1                                                              
VALUE    DS    CL8                                                              
KEYLENX  DS    F                            Max length of current valu          
KEYLEN   DS    F                                length of current valu          
         SPACE 2                                                                
MSGAREA  DS    0XL97                        Output Area                         
MSGAREAF DS    XL5                           WCC                                
MSGAREAM DS    CL90                          Message                            
MSGAREAB DS    XL2                           End field                          
         SPACE 2                                                                
TDMSGA   DS    0XL120                       TD Message area                     
TDMSGN   DS    XL10                            Time                             
TDMSGP1  DS    CL1                                                              
TDMSGTI  DS    XL8                             Time                             
TDMSGP2  DS    CL1                                                              
TDMSGTA  DS    XL8                             Transaction Number               
TDMSGP3  DS    CL1                                                              
TDMSGM   DS    CL90                          Message                            
         DS    CL1                                                              
         SPACE 1                                                                
PH2      DS    XL2                          Conversion areas                    
         DS    0F                                                               
VALU2TO4 DS    XL4                                                              
WORK2TO4 DS    CL8                                                              
PACK2TO4 DS    CL16                                                             
OUTP2TO4 DS    CL4                                                              
PH4      DS    XL4                                                              
         DS    0F                                                               
VALU4TO8 DS    XL4                                                              
WORK4TO8 DS    CL8                                                              
PACK4TO8 DS    CL16                                                             
OUTP4TO8 DS    CL8                                                              
         SPACE 1                                                                
         DS    0D                                                               
SAVE1    DS    XL64                         Save Areas                          
SAVE2    DS    XL64                                                             
SAVE3    DS    XL64                                                             
SAVE4    DS    XL64                                                             
SAVE5    DS    XL64                                                             
SAVE6    DS    XL64                                                             
FSAVE    DS    XL64                                                             
         SPACE 1                                                                
EISEND   DS    0H                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Initialisation                                    =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
RAHWBANL DFHEIENT CODEREG=(R6,R7,R8),                                  |        
               DATAREG=(R9,R10),                                       |        
               EIBREG=(R11)                                                     
         SPACE 2                                                                
RAHWBANL AMODE 31                                                               
RAHWBANL RMODE ANY                                                              
         SPACE 2                                                                
         B     START                                                            
         SPACE 2                                                                
         DC    CL8'RAHWBANL'                                                    
         DC    CL8'&SYSDATE'                                                    
         DC    CL8'&SYSTIME'                                                    
         SPACE 2                                                                
START    DS    0H                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Start of Program                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
RAHWBANL CSECT                                                                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =     Initialise some Variables                                    =          
* ====================================================================          
*                                                                               
         SPACE 1                                                                
*                                                                               
* ====> Initialise variables                                                    
*                                                                               
         SPACE 2                                                                
         ST    DFHEIBR,EIBSAVE              Save the EIB pointer                
         XC    SAVECOMM,SAVECOMM            Clear the Commarea                  
         XC    COMMAREA,COMMAREA                                                
         XC    CAP,CAP                                                          
         XC    CAL,CAL                                                          
         XC    URL,URL                      /url/ area                          
         XC    URLL,URLL                                                        
         MVC   MAXURL,=AL4(L'URL)                                               
         SPACE 1                                                                
*                                                                               
* ====> Set defaults for user supplied items                                    
*                                                                               
         SPACE 1                                                                
RAHWBDEF DS    0H                                                               
         SPACE 1                                                                
         MVC   UTERMID,=XL4'00000000'       Run Non-terminal                    
         MVC   UTRANID,=CL4'CWBA'           Default Transid                     
         MVC   UCONVER,=XL8'0000000000000000' CICS default Converter            
         MVC   UCONVCP,=CL8'DFHWBUD '       Cics defined conversion             
         MVC   UPROGER,=CL8'DFH$WB1A'       Test program                        
         MVC   UUSERID,=CL8'CICSUSER'       Default Security context            
         MVC   UUTOKEN,=XL8'0000000000000000'   No user token                   
         MVC   UUUNESC,=XL1'04'             Unescape not required               
         MVC   URC,=F'0'                    OK Return Code                      
         MVC   UAC,=F'0'                    OK Reason Code                      
         SPACE 2                                                                
*                                                                               
* ====> Variables have been initialised                                         
*                                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =     See how we got going                                         =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 1                                                                
GG       DS    0H                                                               
         SPACE 2                                                                
*                                                                               
* ====> Get Commarea and Length                                                 
*                                                                               
         SPACE 2                                                                
GG1      DS    0H                                                               
         SPACE 1                                                                
         MVC   CAP,DFHEICAP                 Get Commarea Address                
         MVC   CAL+2(2),EIBCALEN            Get Commarea Length                 
         MVC   CALH,EIBCALEN                                                    
         SPACE 1                                                                
GGX      DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* ====> Start Info has been gathered                                            
*                                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =     Look at the Commarea                                         =          
* =                                                                  =          
* =     The Commarea to check that the analyser function is          =          
* =         being requested.                                         =          
* =                                                                  =          
* =     Once this action has been determined, then copy the          =          
* =          now correctly determined Commarea.                      =          
* =                                                                  =          
* ====================================================================          
*                                                                               
*                                                                               
* ====> Grab the Commarea, if its around and OK                                 
*                                                                               
GC       DS    0H                                                               
         SPACE 1                                                                
         L     R15,CAP                        Address the Commarea              
         LTR   R15,R15                        Any Commarea ?                    
         BZ    GC1                             No  - no function                
         L     R14,CAL                        Look at Commarea Length           
         LTR   R14,R14                        Any Commarea ?                    
         BZ    GC1                             No  - no function                
         C     R14,=AL4(L'COMMAREA)           Enough Room for it?               
         BNL   GC1                             No  - no function                
         B     GC2                             Yes - Commarea present           
         SPACE 1                                                                
*                                                                               
* ====> No Commarea around                                                      
*                                                                               
         SPACE 1                                                                
GC1      DS    0H                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         L     R14,=AL4(MSG01)                                                  
         MVC   MSGAREAM,0(R14)                                                  
         SPACE 1                                                                
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
         B     EXITX                                                            
         SPACE 2                                                                
*                                                                               
* ====> See if the Commarea contains a valid function                           
*                                                                               
         SPACE 1                                                                
GC2      DS    0H                                                               
         SPACE 1                                                                
         MVC   CAACT,0(R15)                 Get the Function required           
         OC    CAACT,=XL8'4040404040404040' Put into Upper Case                 
         SPACE 1                                                                
         CLC   CAACT,=CL8'>ANALYZE'         Known function?                     
         BE    GC4                           Yes - continue                     
         B     GC3                           No  - error                        
         SPACE 1                                                                
*                                                                               
* ====> Unknown Commarea function                                               
*                                                                               
         SPACE 1                                                                
GC3      DS    0H                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         L     R14,=AL4(MSG02)                                                  
         MVC   MSGAREAM,0(R14)                                                  
         MVC   MSGAREAM+40(8),CAACT                                             
         SPACE 1                                                                
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
         B     EXITX                                                            
         SPACE 1                                                                
*                                                                               
* ====> Analyse requested, get the Commarea                                     
*                                                                               
         SPACE 1                                                                
GC4      DS    0H                                                               
         SPACE 1                                                                
         L     R14,CAL                      Look at Commarea Length             
         C     R14,=AL4(L'WBRA_PARMS)       Correct Length?                     
         BE    GC41                          Yes - continue                     
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         L     R14,=AL4(MSG03)                                                  
         MVC   MSGAREAM,0(R14)                                                  
         LA    R14,CAL                                                          
         LA    R15,MSGAREAM+50                                                  
         BAL   R5,CONV4TO8                                                      
         SPACE 1                                                                
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
         B     EXITX                                                            
         SPACE 1                                                                
GC41     DS    0H                                                               
         SPACE 1                                                                
         LA    R0,SAVECOMM                  Copy the Analyse Commarea           
         L     R1,=AL4(L'WBRA_PARMS)                                            
         L     R14,CAP                                                          
         LR    R15,R1                                                           
         MVCL  R0,R14                                                           
         SPACE 1                                                                
         MVC   COMMAREA,SAVECOMM            and set the user one                
         SPACE 1                                                                
         B     GCX                          and exit block                      
         SPACE 1                                                                
*                                                                               
* ====> Action and Commarea correctly determined                                
*                                                                               
         SPACE 1                                                                
GCX      DS    0H                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =     Exit to analyse function                                     =          
* =                                                                  =          
* =                                                                  =          
* =  At this point we have determined the Analyse action             =          
* =     required and checked that the Commarea looks OK for the      =          
* =     function.                                                    =          
* =                                                                  =          
* =  Thus, as the processing for this action is its own              =          
* =        CSECT, we now go off to it, returning                     =          
* =        here after the processing has finished                    =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 1                                                                
PC       DS    0H                                                               
         SPACE 2                                                                
         XC    MSGAREA,MSGAREA              Trace Commarea                      
         MVC   MSGAREAM,MSGI2                                                   
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
         L     R15,=AL4(RAHWBANZ)           Address Analyse CSECT               
         BALR  R14,R15                      Run Anaylse actions                 
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace Analyse return                
         MVC   MSGAREAM,MSGI3                                                   
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
*                                                                               
* ====> End of Analyze function                                                 
*                                                                               
         SPACE 1                                                                
PCX      DS    0H                                                               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
* ====================================================================          
* =                                                                  =          
* =      Update the REAL Commarea from the local copy                =          
* =                                                                  =          
* =      The Saved Commarea is first updated with the fields that    =          
* =          are defined to be updateable, and then the whole        =          
* =          of this unsaved commarea is copied back into            =          
* =          the CICS-supplied area.                                 =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
* ====> Trace output commarea                                                   
*                                                                               
         SPACE 1                                                                
CU       DS    0H                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace Commarea                      
         MVC   MSGAREAM,MSGI4                                                   
         MVC   MSGAREAM+24(50),COMMAREA                                         
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
*                                                                               
* ====> Update Commarea for Analyse                                             
*                                                                               
CUD      DS    0H                                                               
         SPACE 1                                                                
         LA    R3,SAVECOMM                  Address User  Commarea              
         USING DFHCOMMAREA,R3                                                   
         SPACE 1                                                                
         MVC   WBRA_ALIAS_TERMID,UTERMID           Terminal                     
         MVC   WBRA_ALIAS_TRANID,UTRANID           Transaction                  
         MVC   WBRA_CONVERTER_PROGRAM,UCONVER      Converter                    
         MVC   WBRA_DFHCNV_KEY,UCONVCP             Conversion                   
         MVC   WBRA_SERVER_PROGRAM,UPROGER         Server Program               
         MVC   WBRA_USERID,UUSERID                 Security Context             
*                                                                               
&A       SETC  T'WBRA_UNESCAPE                                                  
         AIF   ('&A' NE 'G').CUD0                                               
         MVC   WBRA_UNESCAPE,UUUNESC               Unescape setting             
.CUD0    ANOP                                                                   
*                                                                               
         SPACE 1                                                                
         MVC   WBRA_RESPONSE,URC                   Return Code                  
         MVC   WBRA_REASON,UAC                     Reason                       
         SPACE 1                                                                
         DROP  R3                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace results                       
         MVC   MSGAREAM,MSGI5                                                   
         MVI   MSGAREAM+24,C'/'                                                 
         MVC   MSGAREAM+25(04),UTERMID                                          
         MVI   MSGAREAM+29,C'/'                                                 
         MVC   MSGAREAM+30(04),UTRANID                                          
         MVI   MSGAREAM+34,C'/'                                                 
         MVC   MSGAREAM+35(08),UCONVER                                          
         MVI   MSGAREAM+43,C'/'                                                 
         MVC   MSGAREAM+44(08),UCONVCP                                          
         MVI   MSGAREAM+52,C'/'                                                 
         MVC   MSGAREAM+53(08),UPROGER                                          
         MVI   MSGAREAM+61,C'/'                                                 
         MVC   MSGAREAM+62(08),UUSERID                                          
         MVI   MSGAREAM+70,C'/'                                                 
         MVC   MSGAREAM+71(08),UUTOKEN                                          
         MVI   MSGAREAM+79,C'/'                                                 
         MVC   MSGAREAM+80(01),UUUNESC                                          
         MVI   MSGAREAM+81,C'/'                                                 
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
*                                                                               
* ====> Saved commarea has been updated, now update the Real one                
*                                                                               
CUC      DS    0H                                                               
         SPACE 2                                                                
         XC    MSGAREA,MSGAREA              Trace Before Commarea               
         MVC   MSGAREAM,MSGI6                                                   
         L     R1,CAP                                                           
         MVC   MSGAREAM+24(50),0(R1)                                            
         BAL   R5,MSGTOTD                                                       
         SPACE 1                                                                
         L     R0,CAP                       Address Real Commarea               
         L     R1,CAL                       Get Real Commarea len               
         LA    R14,SAVECOMM                 Point to updared saved              
         LR    R15,R1                       No padding                          
         MVCL  R0,R14                       Updates CICS Commarea               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace Real Commarea                 
         MVC   MSGAREAM,MSGI7                                                   
         L     R1,CAP                                                           
         MVC   MSGAREAM+24(50),0(R1)                                            
         BAL   R5,MSGTOTD                                                       
*                                                                               
* ====> Commarea updated with Decode and Encode data                            
*                                                                               
CUX      DS    0H                                                               
         SPACE 2                                                                
         B     EXIT                         and exit CICS                       
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =         End of Logic - return to CICS                            =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
EXITX    DS    0H                                                               
         SPACE 2                                                                
EXIT     DS    0H                                                               
         SPACE 2                                                                
         EXEC  CICS RETURN                                                      
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Constants                                         =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
EISLEN   DC    Y(EISEND-EISSTART)           Length of EXEC Storage              
         SPACE 1                                                                
         SPACE 2                                                                
MSGTDQ   DC    CL4'RAHW'                    Message TDQ                         
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Information Messages                              =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
*                   0....+....1....+....2....+....3....+....4....+....5         
*              ....+....6....+....7....+....8....+....9                         
MSG01    DC    CL90'RAHWB1001S No commarea supplied for Analyser       |        
                                                      '                         
MSG02    DC    CL90'RAHWB1002S Unknown Analyser request of <xxxxxxxx>  |        
                                                      '                         
MSG03    DC    CL90'RAHWB1003S Invalid Commarea length for Analyse of x|        
               xxxxxxx                                '                         
         SPACE 2                                                                
*                   0....+....1....+....2....+....3....+....4....+....5         
*              ....+....6....+....7....+....8....+....9                         
MSGI1    DC    CL90'RAHWB2001I Commarea is <xxxxxxxxxxxxxxxxxxxxxxxxxxx|        
               xxxxxxxxxxxxxxxxxxxxx>                 '                         
MSGI2    DC    CL90'RAHWB2002I About to link to Analyse logic          |        
                                                      '                         
MSGI3    DC    CL90'RAHWB2003I Returned from Analyse logic             |        
                                                      '                         
MSGI4    DC    CL90'RAHWB2004I Commarea is <xxxxxxxxxxxxxxxxxxxxxxxxxxx|        
               xxxxxxxxxxxxxxxxxxxxx>                 '                         
MSGI5    DC    CL90'RAHWB2005I Settings are                            |        
                                                      '                         
MSGI6    DC    CL90'RAHWB2006I Old CA  was <xxxxxxxxxxxxxxxxxxxxxxxxxxx|        
               xxxxxxxxxxxxxxxxxxxxx>                 '                         
MSGI7    DC    CL90'RAHWB2007I Real CA  is <xxxxxxxxxxxxxxxxxxxxxxxxxxx|        
               xxxxxxxxxxxxxxxxxxxxx>                 '                         
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Literals                                          =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         LTORG                                                                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =            Writing Subroutines                                   =          
* =            -------------------                                   =          
* =                                                                  =          
* =   These routines send debugging or Error messages. They are      =          
* =         linked on R5, and use SAVE2 as their Savearea.           =          
* =                                                                  =          
* =                                                                  =          
* =   MSGTOTD -> Write a Message to a TDQ                            =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
*                                                                               
* =====> Output Message to TDQ                                                  
*                                                                               
*               Split the Message so that the message number                    
*                     (1st 10 bytes) comer out before the time and              
*                     transaction number                                        
*                                                                               
         SPACE 2                                                                
MSGTOTD  DS    0H                                                               
         SPACE 2                                                                
         STM   R0,R15,SAVE2                 Save regs                           
         SPACE 1                                                                
         XC    TDMSGA,TDMSGA                                                    
         MVC   TDMSGN,MSGAREAM+0                                                
         MVI   TDMSGP1,C' '                                                     
         UNPK  TDMSGTI,EIBTIME                                                  
         OC    TDMSGTI,=CL8'00000000'                                           
         MVC   TDMSGTI+0(2),TDMSGTI+2                                           
         MVI   TDMSGTI+2,C':'                                                   
         MVC   TDMSGTI+3(2),TDMSGTI+4                                           
         MVI   TDMSGTI+5,C':'                                                   
         MVI   TDMSGP2,C' '                                                     
         MVI   TDMSGTA,C'0'                                                     
         LA    R14,EIBTASKN                                                     
         LA    R15,TDMSGTA+1                                                    
         BAL   R5,CONV4TO8                                                      
         MVI   TDMSGP3,C' '                                                     
         MVC   TDMSGM(80),MSGAREAM+11                                           
         SPACE 1                                                                
         EXEC  CICS WRITEQ TD QUEUE(MSGTDQ)                            |        
               FROM(TDMSGA)                                            |        
               LENGTH(=AL2(L'TDMSGA))                                  |        
               NOHANDLE                                                         
         SPACE 1                                                                
         LM    R0,R15,SAVE2                 Restore regs                        
         BR    R5                           Return                              
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Literals                                          =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         LTORG                                                                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =                Conversion Subroutines                            =          
* =                ----------------------                            =          
* =                                                                  =          
* =   These are general conversion routines. They are all linked     =          
* =         on R5 and use SAVE1 as their savearea                    =          
* =                                                                  =          
* =               R14-> Input   R15->Output                          =          
* =                                                                  =          
* =  CONV2TO4  =  XL2 -> CL4                                         =          
* =  CONV4TO8  =  XL4 -> CL8                                         =          
* =  CONVCTOI  =  CL8 -> F    omitting non-numerics Right-to-Left    =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
*                                                                               
* =====> Convert XL2->CL4  (R14->XL2, R15->CL4)                                 
*                                                                               
         SPACE 2                                                                
CONV2TO4 DS    0H                                                               
         SPACE 2                                                                
         STM   R0,R15,SAVE1                 Save regs                           
         SPACE 1                                                                
         MVC   VALU2TO4,0(R14)              Get Input XL2                       
         SPACE 1                                                                
         MVC   OUTP2TO4,=CL4'00000000'      Clear return area                   
         SPACE 1                                                                
         XR    R14,R14                      Clear Work Reg                      
         IC    R14,VALU2TO4+2               Load Source Byte                    
         N     R14,=XL4'000000F0'           Set the Nibble                      
         SRA   R14,4                        000000x0 -> 0000000x                
         LA    R15,=CL16'0123456789ABCDEF'  Address Pattern                     
         AR    R15,R14                      Point to Printable char             
         MVC   OUTP2TO4+0(1),0(R15)         Save the Printable char             
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU2TO4+2               ..x.                                
         N     R14,=XL4'0000000F'           .x                                  
         LA    R15,=CL16'0123456789ABCDEF'                                      
         AR    R15,R14                                                          
         MVC   OUTP2TO4+1(1),0(R15)         x...                                
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU2TO4+3                                                   
         N     R14,=XL4'000000F0'           ..x.                                
         SRA   R14,4                        000000x0 -> 0000000x                
         LA    R15,=CL16'0123456789ABCDEF'  x.                                  
         AR    R15,R14                                                          
         MVC   OUTP2TO4+2(1),0(R15)         ..x.                                
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU2TO4+3               ...x                                
         N     R14,=XL4'0000000F'           .x                                  
         LA    R15,=CL16'0123456789ABCDEF'                                      
         AR    R15,R14                                                          
         MVC   OUTP2TO4+3(1),0(R15)         ...x                                
         SPACE 1                                                                
         LM    R0,R15,SAVE1                 Restore regs                        
         MVC   0(4,R15),OUTP2TO4            Copy Converted CL4                  
         SPACE 1                                                                
         BR    R5                           Return                              
         SPACE 2                                                                
*                                                                               
* =====> Convert XL4->CL8  (R14->XL4, R15->CL8)                                 
*                                                                               
         SPACE 2                                                                
CONV4TO8 DS    0H                                                               
         SPACE 2                                                                
         STM   R0,R15,SAVE1                 Save regs                           
         SPACE 1                                                                
         MVC   VALU4TO8,0(R14)              Get Input XL4                       
         SPACE 1                                                                
         MVC   OUTP4TO8,=CL8'00000000'      Clear return area                   
         SPACE 1                                                                
         XR    R14,R14                      Clear Work Reg                      
         IC    R14,VALU4TO8+0               Load Source Byte                    
         N     R14,=XL4'000000F0'           Set the Nibble                      
         SRA   R14,4                        000000x0 -> 0000000x                
         LA    R15,=CL16'0123456789ABCDEF'  Address Pattern                     
         AR    R15,R14                      Point to Printable char             
         MVC   OUTP4TO8+0(1),0(R15)         Save the Printable char             
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+0               x...                                
         N     R14,=XL4'0000000F'           .x                                  
         LA    R15,=CL16'0123456789ABCDEF'                                      
         AR    R15,R14                                                          
         MVC   OUTP4TO8+1(1),0(R15)         .x......                            
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+1                                                   
         N     R14,=XL4'000000F0'           .x..                                
         SRA   R14,4                        000000x0 -> 0000000x                
         LA    R15,=CL16'0123456789ABCDEF'  x.                                  
         AR    R15,R14                                                          
         MVC   OUTP4TO8+2(1),0(R15)         ..x.....                            
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+1               .x..                                
         N     R14,=XL4'0000000F'           .x                                  
         LA    R15,=CL16'0123456789ABCDEF'                                      
         AR    R15,R14                                                          
         MVC   OUTP4TO8+3(1),0(R15)         ...x....                            
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+2                                                   
         N     R14,=XL4'000000F0'           ..x.                                
         SRA   R14,4                        000000x0 -> 0000000x                
         LA    R15,=CL16'0123456789ABCDEF'  x.                                  
         AR    R15,R14                                                          
         MVC   OUTP4TO8+4(1),0(R15)         ....x...                            
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+2               ..x.                                
         N     R14,=XL4'0000000F'           .x                                  
         LA    R15,=CL16'0123456789ABCDEF'                                      
         AR    R15,R14                                                          
         MVC   OUTP4TO8+5(1),0(R15)         .....x..                            
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+3                                                   
         N     R14,=XL4'000000F0'           ...x                                
         SRA   R14,4                        000000x0 -> 0000000x                
         LA    R15,=CL16'0123456789ABCDEF'  x.                                  
         AR    R15,R14                                                          
         MVC   OUTP4TO8+6(1),0(R15)         ......x.                            
         SPACE 1                                                                
         XR    R14,R14                                                          
         IC    R14,VALU4TO8+3               ...x                                
         N     R14,=XL4'0000000F'           .x                                  
         LA    R15,=CL16'0123456789ABCDEF'                                      
         AR    R15,R14                                                          
         MVC   OUTP4TO8+7(1),0(R15)         .......x                            
         SPACE 1                                                                
         LM    R0,R15,SAVE1                 Restore regs                        
         MVC   0(8,R15),OUTP4TO8            Copy Converted CL8                  
         BR    R5                           Return                              
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* =====> Convert CL8->F    (R14->CL8, R15->F)                                   
*                                                                               
*        Non numerics      R0 = used in Multiply, ignored                       
*        are ignored       R1 = Char, then numeric Digit                        
*                          R2 = Counter register                                
*                          R4 = used in Multiply, ignored                       
*                          R5 = Next multiplier                                 
         SPACE 2                                                                
CONVCTOI DS    0H                                                               
         SPACE 2                                                                
         STM   R0,R15,SAVE1                 Save regs                           
         SPACE 1                                                                
         XR    R2,R2                        Clear Count Register                
         L     R5,=F'1'                     Initial Multiplier                  
         SPACE 1                                                                
CTOI8    DS    0H                                                               
         SPACE 1                                                                
         CLI   7(R14),C'0'                  Integer?                            
         BL    CTOI7                         No  - omit                         
         CLI   7(R14),C'9'                  Integer?                            
         BH    CTOI7                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',7(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI7    DS    0H                                                               
         SPACE 1                                                                
         CLI   6(R14),C'0'                  Integer?                            
         BL    CTOI6                         No  - omit                         
         CLI   6(R14),C'9'                  Integer?                            
         BH    CTOI6                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',6(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI6    DS    0H                                                               
         SPACE 1                                                                
         CLI   5(R14),C'0'                  Integer?                            
         BL    CTOI5                         No  - omit                         
         CLI   5(R14),C'9'                  Integer?                            
         BH    CTOI5                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',5(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI5    DS    0H                                                               
         SPACE 1                                                                
         CLI   4(R14),C'0'                  Integer?                            
         BL    CTOI4                         No  - omit                         
         CLI   4(R14),C'9'                  Integer?                            
         BH    CTOI4                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',4(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI4    DS    0H                                                               
         SPACE 1                                                                
         CLI   3(R14),C'0'                  Integer?                            
         BL    CTOI3                         No  - omit                         
         CLI   3(R14),C'9'                  Integer?                            
         BH    CTOI3                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',3(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI3    DS    0H                                                               
         SPACE 1                                                                
         CLI   2(R14),C'0'                  Integer?                            
         BL    CTOI2                         No  - omit                         
         CLI   2(R14),C'9'                  Integer?                            
         BH    CTOI2                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',2(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI2    DS    0H                                                               
         SPACE 1                                                                
         CLI   1(R14),C'0'                  Integer?                            
         BL    CTOI1                         No  - omit                         
         CLI   1(R14),C'9'                  Integer?                            
         BH    CTOI1                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',1(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI1    DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),C'0'                  Integer?                            
         BL    CTOI0                         No  - omit                         
         CLI   0(R14),C'9'                  Integer?                            
         BH    CTOI0                         No  - omit                         
         XR    R1,R1                                                            
         ICM   R1,B'0001',0(R14)             Yes - Put into Calc Reg            
         S     R1,=XL4'000000F0'                   Get digit                    
         MR    R0,R5                               Up digit                     
         M     R4,=F'10'                           Up multiplier                
         AR    R2,R1                               Add in integer               
         SPACE 1                                                                
CTOI0    DS    0H                                                               
         SPACE 1                                                                
         ST    R2,0(R15)                    Saved Converted CL8                 
         LM    R0,R15,SAVE1                 Restore regs                        
         BR    R5                           Return                              
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                Literals                                          =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         LTORG                                                                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =                                                                  =          
* =                RAHWBANZ Analyser routine                         =          
* =                -------------------------                         =          
* =                                                                  =          
* =   This routine is the RAHWBANZ analyse processing CSECT.         =          
* =                                                                  =          
* =   It is linked on R14, and resets all the Base Registers for its =          
* =      own use (Data registers are unchanged).                     =          
* =                                                                  =          
* =      So call by L    R15,=AL4(RAHWBANZ)                          =          
* =                 BALR R14,R15                                     =          
* =                                                                  =          
* =                                                                  =          
* =      care must be taken to establish the correct environmemt     =          
* =      when using Mainline functional routines. SAVE5 is used      =          
* =      as the Savearea.                                            =          
* =                                                                  =          
* =                                                                  =          
* =   Processing must look at the commarea supplied (which is        =          
* =      a copy of the one the Web Control called this program       =          
* =      with) and decide upon the settings to be passed back        =          
* =      as a result of the analysis.                                =          
* =                                                                  =          
* =                                                                  =          
* =   If the first thing after the first / is not a &, then the      =          
* =      extended processing provided by this module is not          =          
* =      invoked, and the supplied CICS default analyser             =          
* =      (DFHWBADX) is called,                                       =          
* =                                                                  =          
* =                                                                  =          
* =   Things to be returned:                                         =          
* =                                                                  =          
* =                                                                  =          
* =    UTERMID                 Termid            TE=                 =          
* =    UTRANID                 Transid           TR=                 =          
* =    UCONVER                 Converter         CV=                 =          
* =    UCONVCP                 Conversion        CP=                 =          
* =    UPROGER                 Program           PR=                 =          
* =    UUSERID                 Userid            UI=                 =          
* =    UUUTOKEN                UserToken         UT=                 =          
* =    UUUNESC                 Unescape          UE=                 =          
* =    URC                     RC                                    =          
* =    UAC                     AC                                    =          
* =                                                                  =          
* =    Note that KS= will build all the aforementioned items.        =          
* =                                                                  =          
* =    The UE= setting can be quoted generally, but will only        =          
* =        be used if the 'Unescape' fix has been applied.           =          
* =                                                                  =          
* =                                                                  =          
* =   Register usage :  R6  -> Base Register                         =          
* =                     R7  -> Base Register                         =          
* =                     R8  -> Base Register                         =          
* =                                                                  =          
* =                     all registers are put back into their        =          
* =                     saved state upon return                      =          
* =                                                                  =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
RAHWBANZ CSECT                                                                  
         SPACE 2                                                                
RAHWBANZ AMODE 31                                                               
RAHWBANZ RMODE ANY                                                              
         PUSH USING                         Save Addressibility                 
         USING RAHWBANZ,R6,R7,R8            Set local Addressibility            
         STM   R0,R15,SAVE5                 Save regs                           
         SPACE 1                                                                
*                                                                               
* =====> Establish new Base Registers                                           
*                                                                               
         SPACE 1                                                                
         LR    R6,R15                       Load 1st Base Reg                   
         LA    R7,X'FFF'(,R6)               Set  2nd Base REg                   
         LA    R7,1(,R7)                                                        
         LA    R8,X'FFF'(,R7)               Set  3rd Base REg                   
         LA    R8,1(,R8)                                                        
         SPACE 1                                                                
*                                                                               
* =====> Trace Entry                                                            
*                                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace Entry                         
         MVC   MSGAREAM,MSGAI1                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
*                                                                               
* =====> Address the commarea                                                   
*                                                                               
         SPACE 1                                                                
         LA    R2,COMMAREA                                                      
         USING DFHCOMMAREA,R2                                                   
         SPACE 1                                                                
*                                                                               
* =====> If not an HTTP request, pass to default analyser                       
*                                                                               
         SPACE 1                                                                
AZU0     DS    0H                                                               
         SPACE 1                                                                
         CLC   WBRA_HTTP_VERSION_LENGTH,=H'0'   HTTP request?                   
         BNE   AZU01                             yes - keep going               
         SPACE 1                                 no  - use CICS                 
         MVC   MSGAREAM,MSGAI2                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
*                                                                               
* =====> If there is no HTTP header, use CICS                                   
*                                                                               
         SPACE 1                                                                
AZU01    DS    0H                                                               
         SPACE 1                                                                
         L     R1,WBRA_RESOURCE_PTR         Address Commarea                    
         LTR   R1,R1                          Any HTTP at all?                  
         BNE   AZU02                           Yes - keep going                 
         SPACE 1                               No  - use CICS                   
         MVC   MSGAREAM,MSGAI3                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
AZU02    DS    0H                                                               
         SPACE 1                                                                
         LH    R2,WBRA_RESOURCE_LENGTH      Look at Commarea len                
         DROP  R2                                                               
         LTR   R2,R2                        Any HTTP at all?                    
         BNE   AZU03                         Yes - keep going                   
         SPACE 1                             No  - use CICS                     
         MVC   MSGAREAM,MSGAI4                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
AZU03    DS    0H                                                               
         SPACE 1                                                                
         MVC   MSGAREAM,MSGAI5                                                  
         MVC   MSGAREAM+27(50),0(R1)                                            
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZU1                                                             
         SPACE 1                                                                
*                                                                               
* =====> Save the current URL between the first and second slashs               
*                                                                               
         SPACE 1                                                                
AZU1     DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R1),C'/'                   Found 1st Slash?                    
         BE    AZU2                          Yes - start looking                
         SH    R2,=H'1'                      No  - down header left             
         LA    R1,1(,R1)                           up header pointer            
         LTR   R2,R2                               Any more header?             
         BNE   AZU1                                 Yes - keep going            
         SPACE 1                                    No  - use CICS              
         MVC   MSGAREAM,MSGAI6                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
         SPACE 1                                                                
AZU2     DS    0H                                                               
         SPACE 1                                                                
         LA    R1,1(,R1)                     Up Header                          
         SH    R2,=H'1'                      Down Header counter                
         LTR   R2,R2                         Any more header?                   
         BNE   AZU3                            Yes - keep going                 
         SPACE 1                               No  - use CICS                   
         MVC   MSGAREAM,MSGAI7                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
AZU3     DS    0H                                                               
         SPACE 1                                                                
         XR    R3,R3                         Clear URL Counter                  
         LA    R4,URL                        Point to URL area                  
         SPACE 1                                                                
AZU4     DS    0H                                                               
         SPACE 1                                                                
         MVC   0(1,R4),0(R1)                 Copy URL byte                      
         LA    R3,1(,R3)                     Up URL Length                      
         ST    R3,URLL                       Save URL Length                    
         LA    R4,1(,R4)                     Point to next free byte            
         C     R3,MAXURL                     Any more room?                     
         BNH   AZU5                           Yes - keep going                  
         SPACE 1                              No  - use CICS                    
         MVC   MSGAREAM,MSGAI8                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
AZU5     DS    0H                                                               
         SPACE 1                                                                
         LA    R1,1(,R1)                     Up Header                          
         SH    R2,=H'1'                      Down Header counter                
         LTR   R2,R2                         Any more header?                   
         BNE   AZU6                           Yes - keep going                  
         SPACE 1                              No  - use CICS                    
         MVC   MSGAREAM,MSGAI9                                                  
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
AZU6     DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R1),C'/'                    Found the 2nd slash?               
         BNE   AZU4                           No  - keep going                  
         B     AZU7                           Yes - end of URL                  
         SPACE 1                                                                
AZU7     DS    0H                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace Obtained URL                  
         MVC   MSGAREAM,MSGAI10                                                 
         MVC   MSGAREAM+26(50),URL                                              
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
*                                                                               
* =====> If it is not a special one (&) then use CICS                           
*                                                                               
         SPACE 1                                                                
AZU8     DS    0H                                                               
         SPACE 1                                                                
         CLI   URL,C'&&'                    Special one?                        
         BE    AZU9                          Yes - keep going                   
         SPACE 1                             No  - use CICS                     
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI11                                                 
         MVC   MSGAREAM+26(50),URL                                              
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     DODFH                                                            
         SPACE 1                                                                
*                                                                               
* =====> Special URL located                                                    
*                                                                               
         SPACE 1                                                                
AZU9     DS    0H                                                               
         SPACE 1                                                                
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI12                                                 
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
*                                                                               
* =====> Scan through the url looking for k=v                                   
*                                                                               
         SPACE 1                                                                
AZK      DS    0H                                                               
         SPACE 1                                                                
AZK0     DS    0H                                                               
         SPACE 1                                                                
         LA    R2,URL+1                     Start of URL                        
         L     R3,URLL                      Length of URL                       
         SH    R3,=H'1'                                                         
         SPACE 1                                                                
AZK1     DS    0H                                                               
         SPACE 1                                                                
         CH    R3,=H'3'                     Any more to do?                     
         BL    AZKX                          No - got them all                  
         SPACE 1                                                                
         MVC   KEY,0(R2)                    Copy the KK=                        
         OC    KEY,=XL3'404040'             Convert to upper case               
         SPACE 1                                                                
*                                                                               
* =====> detect valid keys                                                      
*                                                                               
         SPACE 1                                                                
         CLC   KEY,=CL3'TE='                Terminal?                           
         BE    AZK2TE                                                           
         CLC   KEY,=CL3'TR='                Transaction?                        
         BE    AZK2TR                                                           
         CLC   KEY,=CL3'CV='                Converter?                          
         BE    AZK2CV                                                           
         CLC   KEY,=CL3'CP='                Code Page?                          
         BE    AZK2CP                                                           
         CLC   KEY,=CL3'PR='                Program?                            
         BE    AZK2PR                                                           
         CLC   KEY,=CL3'UI='                Userid?                             
         BE    AZK2UI                                                           
         CLC   KEY,=CL3'UT='                UserToken?                          
         BE    AZK2UT                                                           
         CLC   KEY,=CL3'UE='                Unescape?                           
         BE    AZK2UE                                                           
         CLC   KEY,=CL3'KS='                KeySet?                             
         BE    AZK2KS                                                           
         SPACE 1                            Ignore unknown key                  
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI13                                                 
         MVC   MSGAREAM+23(3),KEY                                               
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                Set max permissable size            
         B     AZK3                         and scan over                       
         SPACE 1                                                                
*                                                                               
* =====> set max value sizes                                                    
*                                                                               
         SPACE 1                                                                
         SPACE 1                                                                
AZK2TE   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'4'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2TR   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'4'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2CV   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2CP   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2PR   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2UI   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2UT   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2UE   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'1'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
AZK2KS   DS    0H                                                               
         SPACE 1                                                                
         MVC   KEYLENX,=F'8'                                                    
         B     AZK3                                                             
         SPACE 1                                                                
*                                                                               
* =====> obtain values                                                          
*                                                                               
         SPACE 1                                                                
AZK3     DS    0H                                                               
         SPACE 1                                                                
         LA    R2,3(,R2)                    Point to next value                 
         SH    R3,=H'3'                     Down length remaining               
         XR    R14,R14                      Clear count reg                     
         LA    R15,VALUE                    Address value area                  
         MVC   VALUE,=CL8' '                Clear value area                    
         SPACE 1                                                                
AZK31    DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R2),C'&&'                  Divider?                            
         BE    AZK32                         Yes  - no more to copy             
         CLI   0(R2),X'41'                  Funny char?                         
         BL    AZK32                         Yes  - no more to copy             
         SPACE 1                                                                
         MVC   0(1,R15),0(R2)                No   - copy byte                   
         LA    R15,1(,R15)                          up value pointer            
         LA    R14,1(,R14)                          up value counter            
         LA    R2,1(,R2)                            up next source              
         SH    R3,=H'1'                             down source len             
         SPACE 1                                                                
         LTR   R3,R3                         Any more source?                   
         BE    AZK32                          No   - no more to copy            
         C     R14,KEYLENX                   Any more room?                     
         BNH   AZK31                          Yes - keep going                  
         SPACE 1                                                                
AZK32    DS    0H                                                               
         SPACE 1                                                                
         OC    VALUE,=XL8'4040404040404040'  Force Values to Uppercase          
         SPACE 1                                                                
         B     AZK4                                                             
         SPACE 1                                                                
*                                                                               
* =====> set values                                                             
*                                                                               
         SPACE 1                                                                
AZK4     DS    0H                                                               
         SPACE 1                                                                
         CLC   KEY,=CL3'TE='                Terminal?                           
         BE    AZK4TE                                                           
         CLC   KEY,=CL3'TR='                Transaction?                        
         BE    AZK4TR                                                           
         CLC   KEY,=CL3'CV='                Converter?                          
         BE    AZK4CV                                                           
         CLC   KEY,=CL3'CP='                Code Page?                          
         BE    AZK4CP                                                           
         CLC   KEY,=CL3'PR='                Program?                            
         BE    AZK4PR                                                           
         CLC   KEY,=CL3'UI='                Userid?                             
         BE    AZK4UI                                                           
         CLC   KEY,=CL3'UT='                UserToken?                          
         BE    AZK4UI                                                           
         CLC   KEY,=CL3'UE='                Unescape?                           
         BE    AZK4UE                                                           
         CLC   KEY,=CL3'KS='                KeySet?                             
         BE    AZK4KS                                                           
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4TE   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign Terminal                                              
*                                                                               
         LA    R14,VALIDTE                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4TE2                       Yes - accept setting               
         SPACE 1                                                                
AZK4TE1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4TEN                       Yes - reject setting               
         CLC   0(4,R14),VALUE               Allowed Entry?                      
         BE    AZK4TE2                       Yes - accept it                    
         LA    R14,4(,R14)                   No  - up pointer                   
         B     AZK4TE1                             and reloop                   
         SPACE 1                                                                
AZK4TE2  DS    0H                                                               
         SPACE 1                                                                
         CLC   VALUE(4),=CL4'NO  '          No setting required?                
         BNE   AZK4TE3                       No  - keep it                      
         MVC   VALUE,=XL8'0000000000000000'  Yes - clear it                     
         SPACE 1                                                                
AZK4TE3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4TEY                      OK setting                          
         SPACE 1                                                                
AZK4TEN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(04),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4TEY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UTERMID,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(04),UTERMID                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4TR   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign Transaction                                           
*                                                                               
         LA    R14,VALIDTR                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4TR2                       Yes - accept setting               
         SPACE 1                                                                
AZK4TR1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4TRN                       Yes - reject setting               
         CLC   0(4,R14),VALUE               Allowed Entry?                      
         BE    AZK4TR2                       Yes - accept it                    
         LA    R14,4(,R14)                   No  - up pointer                   
         B     AZK4TR1                             and reloop                   
         SPACE 1                                                                
AZK4TR2  DS    0H                                                               
         SPACE 1                                                                
         SPACE 1                                                                
AZK4TR3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4TRY                      OK setting                          
         SPACE 1                                                                
AZK4TRN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(04),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4TRY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UTRANID,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(04),UTRANID                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4CV   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign Converter Program                                     
*                                                                               
         LA    R14,VALIDCV                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4CV2                       Yes - accept setting               
         SPACE 1                                                                
AZK4CV1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4CVN                       Yes - reject setting               
         CLC   0(8,R14),VALUE               Allowed Entry?                      
         BE    AZK4CV2                       Yes - accept it                    
         LA    R14,8(,R14)                   No  - up pointer                   
         B     AZK4CV1                             and reloop                   
         SPACE 1                                                                
AZK4CV2  DS    0H                                                               
         SPACE 1                                                                
         CLC   VALUE,=CL8'NO      '         No setting required?                
         BNE   AZK4CV3                       No  - keep it                      
         MVC   VALUE,=XL8'0000000000000000'  Yes - clear it                     
         SPACE 1                                                                
AZK4CV3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4CVY                      OK setting                          
         SPACE 1                                                                
AZK4CVN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(08),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4CVY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UCONVER,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(08),UCONVER                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4CP   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign Code Page Translation                                 
*                                                                               
         LA    R14,VALIDCP                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4CP2                       Yes - accept setting               
         SPACE 1                                                                
AZK4CP1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4CPN                       Yes - reject setting               
         CLC   0(8,R14),VALUE               Allowed Entry?                      
         BE    AZK4CP2                       Yes - accept it                    
         LA    R14,8(,R14)                   No  - up pointer                   
         B     AZK4CP1                             and reloop                   
         SPACE 1                                                                
AZK4CP2  DS    0H                                                               
         SPACE 1                                                                
         CLC   VALUE,=CL8'NO      '         No setting required?                
         BNE   AZK4CP3                       No  - keep it                      
         MVC   VALUE,=XL8'0000000000000000'  Yes - clear it                     
         SPACE 1                                                                
AZK4CP3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4CPY                      OK setting                          
         SPACE 1                                                                
AZK4CPN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(08),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4CPY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UCONVCP,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(08),UCONVCP                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4PR   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign Server Program                                        
*                                                                               
         LA    R14,VALIDPR                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4PR2                       Yes - accept setting               
         SPACE 1                                                                
AZK4PR1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4PRN                       Yes - reject setting               
         CLC   0(8,R14),VALUE               Allowed Entry?                      
         BE    AZK4PR2                       Yes - accept it                    
         LA    R14,8(,R14)                   No  - up pointer                   
         B     AZK4PR1                             and reloop                   
         SPACE 1                                                                
AZK4PR2  DS    0H                                                               
         SPACE 1                                                                
         SPACE 1                                                                
AZK4PR3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4PRY                      OK setting                          
         SPACE 1                                                                
AZK4PRN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(08),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4PRY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UPROGER,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(08),UPROGER                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4UI   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign UserId                                                
*                                                                               
         LA    R14,VALIDUI                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4UI2                       Yes - accept setting               
         SPACE 1                                                                
AZK4UI1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4UIN                       Yes - reject setting               
         CLC   0(8,R14),VALUE               Allowed Entry?                      
         BE    AZK4UI2                       Yes - accept it                    
         LA    R14,8(,R14)                   No  - up pointer                   
         B     AZK4UI1                             and reloop                   
         SPACE 1                                                                
AZK4UI2  DS    0H                                                               
         SPACE 1                                                                
         SPACE 1                                                                
AZK4UI3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4UIY                      OK setting                          
         SPACE 1                                                                
AZK4UIN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(08),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4UIY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UUSERID,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(08),UUSERID                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4UT   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign User Token                                            
*                                                                               
         LA    R14,VALIDUT                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4UT2                       Yes - accept setting               
         SPACE 1                                                                
AZK4UT1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4UTN                       Yes - reject setting               
         CLC   0(8,R14),VALUE               Allowed Entry?                      
         BE    AZK4UT2                       Yes - accept it                    
         LA    R14,8(,R14)                   No  - up pointer                   
         B     AZK4UT1                             and reloop                   
         SPACE 1                                                                
AZK4UT2  DS    0H                                                               
         SPACE 1                                                                
         CLC   VALUE,=CL8'NO      '         No setting required?                
         BNE   AZK4UT3                       No  - keep it                      
         MVC   VALUE,=XL8'0000000000000000'  Yes - clear it                     
         SPACE 1                                                                
AZK4UT3  DS    0H                                                               
         SPACE 1                                                                
         B     AZK4UTY                      OK setting                          
         SPACE 1                                                                
AZK4UTN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(08),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4UTY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UUTOKEN,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(08),UUTOKEN                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4UE   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign Unescape                                              
*                                                                               
         LA    R14,VALIDUE                  Address Validation Table            
         CLI   0(R14),X'FF'                 Allow everything?                   
         BE    AZK4UE2                       Yes - accept setting               
         SPACE 1                                                                
AZK4UE1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4UEN                       Yes - reject setting               
         CLC   0(1,R14),VALUE               Allowed Entry?                      
         BE    AZK4UE2                       Yes - accept it                    
         LA    R14,1(,R14)                   No  - up pointer                   
         B     AZK4UE1                             and reloop                   
         SPACE 1                                                                
AZK4UE2  DS    0H                                                               
         SPACE 1                                                                
         CLI   VALUE,C'Y'                   Unescape = Yes?                     
         BNE   AZK4UE3                       Yes                                
         MVI   UUUNESC,X'03'                 Set Unescape Required              
         B     AZK4UEY                       OK setting                         
         SPACE 1                                                                
AZK4UE3  DS    0H                                                               
         SPACE 1                                                                
         MVI   UUUNESC,X'04'                 Set Unescape not required          
         B     AZK4UEY                       OK setting                         
         SPACE 1                                                                
AZK4UEN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(01),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4UEY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(01),UUUNESC                                          
         MVC   MSGAREAM+26(01),=CL1'/'                                          
         MVC   MSGAREAM+27(01),VALUE                                            
         MVC   MSGAREAM+28(01),=CL1'/'                                          
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
AZK4KS   DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> check and assign KeySet                                                
*                                                                               
         LA    R14,KEYSET                   Address KeySet Table                
         USING KEYSETDS,R14                                                     
         SPACE 1                                                                
AZK4KS1  DS    0H                                                               
         SPACE 1                                                                
         CLI   0(R14),X'FF'                 End of list?                        
         BE    AZK4KSN                       Yes - reject setting               
         CLC   KSNA,VALUE                   Matched Entry?                      
         BE    AZK4KSY                       Yes - accept it                    
         AH    R14,=AL2(KSLEN)               No  - up pointer                   
         B     AZK4KS1                             and reloop                   
         SPACE 1                                                                
AZK4KSN  DS    0H                           Reject Setting                      
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI14                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+21(08),VALUE                                            
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 1                                                                
AZK4KSY  DS    0H                           Accept Setting                      
         SPACE 1                                                                
         MVC   UTERMID,KSTE                 Copy Values from those              
         MVC   UTRANID,KSTR                 defined in the KeySet               
         MVC   UCONVER,KSCV                                                     
         MVC   UCONVCP,KSCP                                                     
         MVC   UPROGER,KSPR                                                     
         MVC   UUSERID,KSUI                                                     
         MVC   UUTOKEN,KSUT                                                     
         SPACE 1                                                                
         CLI   KSUE,C'Y'                    Unescape = Yes?                     
         BNE   AZK4KSY1                      Yes                                
         MVI   UUUNESC,X'03'                 Set Unescape Required              
         B     AZK4KSY2                      OK setting                         
         SPACE 1                                                                
AZK4KSY1 DS    0H                                                               
         SPACE 1                                                                
         MVI   UUUNESC,X'04'                 Set Unescape not required          
         B     AZK4KSY2                      OK setting                         
         SPACE 1                                                                
AZK4KSY2 DS    0H                                                               
         SPACE 1                                                                
         DROP  R14                                                              
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI15                                                 
         MVC   MSGAREAM+15(02),KEY                                              
         MVC   MSGAREAM+25(04),UTERMID                                          
         MVI   MSGAREAM+29,C'/'                                                 
         MVC   MSGAREAM+30(04),UTRANID                                          
         MVI   MSGAREAM+34,C'/'                                                 
         MVC   MSGAREAM+35(08),UCONVER                                          
         MVI   MSGAREAM+43,C'/'                                                 
         MVC   MSGAREAM+44(08),UCONVCP                                          
         MVI   MSGAREAM+52,C'/'                                                 
         MVC   MSGAREAM+53(08),UPROGER                                          
         MVI   MSGAREAM+61,C'/'                                                 
         MVC   MSGAREAM+62(08),UUSERID                                          
         MVI   MSGAREAM+70,C'/'                                                 
         MVC   MSGAREAM+71(08),UUTOKEN                                          
         MVI   MSGAREAM+79,C'/'                                                 
         MVC   MSGAREAM+80(01),UUUNESC                                          
         MVI   MSGAREAM+81,C'/'                                                 
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         B     AZK4X                                                            
         SPACE 2                                                                
         SPACE 1                                                                
*                                                                               
* =====> End of value processing                                                
*                                                                               
         SPACE 1                                                                
AZK4X    DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> scan for more entries                                                  
*                                                                               
         SPACE 1                                                                
AZK5     DS    0H                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI16                                                 
         MVC   MSGAREAM+14(8),0(R2)                                             
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         LA    R14,FSAVE+12                                                     
         LA    R15,MSGAREAM+25                                                  
         L     R1,=AL4(CONV4TO8)                                                
         LM    R2,R13,SAVE5+8                                                   
         BALR  R5,R1                                                            
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         CLI   0(R2),C'&&'                  Ended at a boundary?                
         BNE   AZK51                         No  - stop scanning                
         LA    R2,1(,R2)                     Yes - up to next one               
         SH    R3,=H'1'                            down remaining               
         B     AZK1                                and reloop                   
         SPACE 1                                                                
AZK51    DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> End of special scannings                                               
*                                                                               
         SPACE 1                                                                
AZKX     DS    0H                                                               
         SPACE 1                                                                
         MVC   URC,=F'0'                    Set OK RC                           
         MVC   UAC,=F'0'                    Set OK AC                           
         B     AZX                          and exit                            
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* =====> Run using the CICS default analyser                                    
*                                                                               
         SPACE 2                                                                
DODFH    DS    0H                                                               
         SPACE 1                                                                
DC       DS    0H                                                               
         SPACE 1                                                                
         MVC   UUSERID,VALUE                                                    
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI17                                                 
         MVC   MSGAREAM+42(8),DFHAZ                                             
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
*                                                                               
* =====> Link to default CICS Analyser                                          
*                                                                               
         SPACE 1                                                                
DC0      DS    0H                                                               
         SPACE 1                                                                
         EXEC  CICS LINK PROGRAM(DFHAZ)                                |        
                         COMMAREA(COMMAREA)                            |        
                         LENGTH(CALH)                                  |        
                         NOHANDLE                                      |        
                         RESP(RESP)                                    |        
                         RESP2(RESP2)                                           
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA              Trace Exit                          
         MVC   MSGAREAM,MSGAI18                                                 
         STM   R0,R15,FSAVE                                                     
         LA    R14,RESP                                                         
         LA    R15,MSGAREAM+28                                                  
         L     R1,=AL4(CONV4TO8)                                                
         LM    R2,R13,SAVE5+8                                                   
         BALR  R5,R1                                                            
         LM    R0,R15,FSAVE                                                     
         LA    R14,RESP2                                                        
         LA    R15,MSGAREAM+37                                                  
         L     R1,=AL4(CONV4TO8)                                                
         LM    R2,R13,SAVE5+8                                                   
         BALR  R5,R1                                                            
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         SPACE 1                                                                
DC1      DS    0H                                                               
         SPACE 1                                                                
*                                                                               
* =====> Extract from Commarea the fields of interest                           
*                                                                               
         SPACE 1                                                                
         LA    R2,COMMAREA                                                      
         USING DFHCOMMAREA,R2                                                   
         SPACE 1                                                                
         MVC   UTERMID,WBRA_ALIAS_TERMID                                        
         MVC   UTRANID,WBRA_ALIAS_TRANID                                        
         MVC   UCONVER,WBRA_CONVERTER_PROGRAM                                   
         MVC   UCONVCP,WBRA_DFHCNV_KEY                                          
         MVC   UPROGER,WBRA_SERVER_PROGRAM                                      
         MVC   UUSERID,WBRA_USERID                                              
         MVC   UUTOKEN,WBRA_USER_TOKEN                                          
*                                                                               
&A       SETC  T'WBRA_UNESCAPE                                                  
         AIF   ('&A' NE 'G').DC10                                               
         MVC   UUUNESC,WBRA_UNESCAPE             Unescape setting               
.DC10    ANOP                                                                   
*                                                                               
         MVC   URC,WBRA_RESPONSE                                                
         MVC   UAC,WBRA_REASON                                                  
         SPACE 1                                                                
         DROP  R2                                                               
         SPACE 1                                                                
DCX      DS    0H                                                               
         SPACE 1                                                                
         B     AZX                          and return to caller                
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* =====> Return to caller                                                       
*                                                                               
         SPACE 1                                                                
AZX      DS    0H                                                               
         SPACE 1                                                                
         XC    MSGAREA,MSGAREA                                                  
         MVC   MSGAREAM,MSGAI19             Trace exit                          
         STM   R0,R15,FSAVE                                                     
         L     R15,=AL4(MSGTOTD)                                                
         LM    R0,R14,SAVE5                                                     
         BALR  R5,R15                                                           
         LM    R0,R15,FSAVE                                                     
         SPACE 1                                                                
         LM    R0,R15,SAVE5                 Restore regs                        
         BR    R14                          Return                              
         POP   USING                        Restore Addressibility              
         SPACE 2                                                                
*                                                                               
* =====> Analyse Info Messages                                                  
*                                                                               
*                   0....+....1....+....2....+....3....+....4....+....5         
*              ....+....6....+....7....+....8....+....9                         
MSGAI1   DC    CL90'RAHWB3001I Entering Analyse routine                |        
                                                      '                         
MSGAI2   DC    CL90'RAHWB3002I Not an HTTP request, using CICS Analyser|        
                (version)                             '                         
MSGAI3   DC    CL90'RAHWB3003I Not an HTTP request, using CICS Analyser|        
                (pointer)                             '                         
MSGAI4   DC    CL90'RAHWB3004I Not an HTTP request, using CICS Analyser|        
                (length)                              '                         
MSGAI5   DC    CL90'RAHWB3005I Scanning URL of                         |        
                                                      '                         
MSGAI6   DC    CL90'RAHWB3006I Special format not found, using CICS Ana|        
               lyser (1st /)                          '                         
MSGAI7   DC    CL90'RAHWB3007I Special format not found, using CICS Ana|        
               lyser (between /)                      '                         
MSGAI8   DC    CL90'RAHWB3008I Special format not found, using CICS Ana|        
               lyser (length)                         '                         
MSGAI9   DC    CL90'RAHWB3009I Special format not found, using CICS Ana|        
               lyser (unslashed)                      '                         
MSGAI10  DC    CL90'RAHWB3010I URL is                                  |        
                                                      '                         
MSGAI11  DC    CL90'RAHWB3011I Special format not found, using CICS Ana|        
               lyser (no &&)                          '                         
MSGAI12  DC    CL90'RAHWB3012I Special format found, processing        |        
                                                      '                         
*                   0....+....1....+....2....+....3....+....4....+....5         
*              ....+....6....+....7....+....8....+....9                         
MSGAI13  DC    CL90'RAHWB3013I Unknown key xxx ignored                 |        
                                                      '                         
MSGAI14  DC    CL90'RAHWB3014I Key xx of x        was invalid          |        
                                                      '                         
MSGAI15  DC    CL90'RAHWB3015I Key xx set to x                         |        
                                                      '                         
MSGAI16  DC    CL90'RAHWB3016I At xxxxxxxx l(xxxxxxxx)                 |        
                                                      '                         
MSGAI17  DC    CL90'RAHWB3017I Invoking default CICS analyser xxxxxxxx |        
                                                      '                         
MSGAI18  DC    CL90'RAHWB3018I XC Link returned xxxxxxxx/xxxxxxxx      |        
                                                      '                         
MSGAI19  DC    CL90'RAHWB3019I Leaving Analyse routine                 |        
                                                      '                         
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =             Analyse Constants                                    =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
DFHAZ    DC    CL8'DFHWBADX'                Default CICS Analyser               
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =             Analyse Validations                                  =          
* =             -------------------                                  =          
* =                                                                  =          
* =   This section of constants defines the acceptable values        =          
* =        of keys supplied in the URL. Terminate each list by       =          
* =        a line of X'FF's.                                         =          
* =                                                                  =          
* =   If the validation list starts with a X'FF', then anything      =          
* =      supplied in the URL is acceptable.                          =          
* =                                                                  =          
* =   If entries are being checked, then ensure that a NO entry      =          
* =      is supplied for those cases where nulls are required        =          
* =      by the analyser (or else the NO setting will be rejected).  =          
* =                                                                  =          
* =      Everything must be coded in UpperCase.                      =          
* =                                                                  =          
* =   Do not forget that settings in here have to match up with      =          
* =      other CICS Definitions (Logonids, Conversion Templates,     =          
* =      programs, transactions, terminals etc.).                    =          
* =                                                                  =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
VALIDATE DS    0H                                                               
         SPACE 2                                                                
*                                                                               
* =====> Validate terminal (CL4 LS) ; No required                               
*                                                                               
         SPACE 2                                                                
VALIDTE  DS    0H                                                               
         SPACE 1                                                                
*                                           No terminals allowed                
         DC    CL4'NO  '                    Permit non-terminal                 
         DC    XL4'FFFFFFFF'                End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate transaction (CL4 LS)                                          
*                                                                               
         SPACE 2                                                                
VALIDTR  DS    0H                                                               
         SPACE 1                                                                
*                                           All permitted                       
         DC    XL4'FFFFFFFF'                End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate Converter program (CL8 LS) ; No permitted                     
*                                                                               
         SPACE 2                                                                
VALIDCV  DS    0H                                                               
         SPACE 1                                                                
*                                           All permitted (inc NO)              
         DC    XL8'FFFFFFFFFFFFFFFF'        End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate Conversion Key (CL8 LS) ; No permitted                        
*                                                                               
         SPACE 2                                                                
VALIDCP  DS    0H                                                               
         SPACE 1                                                                
         DC    CL8'NO      '                No Conversion                       
         DC    CL8'DFHWBUD '                Standard Web Conversion             
         DC    XL8'FFFFFFFFFFFFFFFF'        End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate Server Program (CL8 LS)                                       
*                                                                               
         SPACE 2                                                                
VALIDPR  DS    0H                                                               
         SPACE 1                                                                
*                                           All permitted                       
         DC    XL8'FFFFFFFFFFFFFFFF'        End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate UserId (CL8 LS)                                               
*                                                                               
         SPACE 2                                                                
VALIDUI  DS    0H                                                               
         SPACE 1                                                                
*                                           Restricted users                    
*        DC    CL8'CICSUSER'                Standard Web Conversion             
         DC    XL8'FFFFFFFFFFFFFFFF'        End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate UserToken (CL8 LS)                                            
*                                                                               
         SPACE 2                                                                
VALIDUT  DS    0H                                                               
         SPACE 1                                                                
*                                           All permitted                       
         DC    XL8'FFFFFFFFFFFFFFFF'        End of list                         
         SPACE 2                                                                
*                                                                               
* =====> Validate Unescape (CL1 LS, Y|N)                                        
*                                                                               
         SPACE 2                                                                
VALIDUE  DS    0H                                                               
         SPACE 1                                                                
*                                                                               
         DC    CL1'N'                       Unescape Yes                        
         DC    CL1'Y'                       Unescape No                         
         DC    XL8'FFFFFFFFFFFFFFFF'        End of list                         
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =             Analyse Keysets                                      =          
* =                                                                  =          
* =  The keysets are a group of pre-defined settings, specified      =          
* =      as required for the analyser (no NO processing).            =          
* =                                                                  =          
* =      Everything must be coded in UpperCase.                      =          
* =                                                                  =          
* =                                                                  =          
* =  Terminate the list of Keysets with XL8'FFFFFFFFFFFFFFF'.        =          
* =                                                                  =          
* =  The layout of a Keyset is:                                      =          
* =                                                                  =          
* =      CL8    Keyset name                                          =          
* =      CL4    Termid  (or XL4'00000000' for non-terminal)          =          
* =      CL4    Transid                                              =          
* =      CL8    Converter program                                    =          
* =      CL8    Conversion Key ( or XL8'00' for no conversion)       =          
* =      CL8    Server program                                       =          
* =      CL8    Userid                                               =          
* =      CL8    User Token (or XL8 as required)                      =          
* =      CL1    Unescape setting (Y|N)                               =          
* =                                                                  =          
* =                                                                  =          
* =                                                                  =          
* =    Supplied KeySets                                              =          
* =    ----------------                                              =          
* =                                                                  =          
* =    IMAGE   | are setup for SupportPac CA87 which provides        =          
* =    LINK    | Rexx/CICS facilities for Image (no translation)     =          
* =            | and normal HTML (with translation) processing       =          
* =                                                                  =          
* =    3270      Run Bridged Transactions which use BMS              =          
* =                                                                  =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
KEYSET   DS    0H                                                               
         SPACE 2                                                                
*                                                                               
* =====> Keyset for standard image processing                                   
*                                                                               
         SPACE 2                                                                
         DC    CL8'IMAGE   '               Name of Keyset                       
         DC    XL4'00000000'               Run non-terminal                     
         DC    CL4'RHRX'                   Use CICS Alias tran                  
         DC    CL8'RAHRCONV'               Rexx Converter program               
         DC    XL8'0000000000000000'       No CodePage Conversion               
         DC    XL8'0000000000000000'       No Server Program                    
         DC    CL8'CICSUSER'               Default CICS Userid                  
         DC    XL8'0000000000000000'       No UserToken                         
         DC    CL1'N'                      Unescape(NO)                         
         SPACE 2                                                                
*                                                                               
* =====> Keyset for standard link processing                                    
*                                                                               
         SPACE 2                                                                
         DC    CL8'LINK    '               Name of Keyset                       
         DC    XL4'00000000'               Run non-terminal                     
         DC    CL4'RHRX'                   Use CICS Alias tran                  
         DC    CL8'RAHRCONV'               Rexx Converter program               
         DC    CL8'DFHWBUD '               EDCDIC<->ASCII conversion            
         DC    XL8'0000000000000000'       Server Program                       
         DC    CL8'CICSUSER'               Default CICS Userid                  
         DC    XL8'0000000000000000'       No UserToken                         
         DC    CL1'N'                      Unescape(NO)                         
         SPACE 2                                                                
*                                                                               
* =====> Keyset for standard link processing                                    
*                                                                               
         SPACE 2                                                                
         DC    CL8'3270    '               Name of Keyset                       
         DC    XL4'00000000'               Run non-terminal                     
         DC    CL4'CWBA'                   Use CICS Alias tran                  
         DC    XL8'0000000000000000'       No Converter program                 
         DC    CL8'DFHWBUD '               EDCDIC<->ASCII conversion            
         DC    CL8'DFHWBTTA'               Server Program                       
         DC    CL8'CICSUSER'               Default CICS Userid                  
         DC    XL8'0000000000000000'       No UserToken                         
         DC    CL1'N'                      Unescape(NO)                         
         SPACE 2                                                                
*                                                                               
* =====> End of KeySet table                                                    
*                                                                               
         SPACE 2                                                                
         DC    XL8'FFFFFFFFFFFFFFFF'       End of KeySet table                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
         EJECT                                                                  
*                                                                               
* ====================================================================          
* =             Analyse Literals                                     =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         LTORG                                                                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =             Revert back to main CSECT                            =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
RAHWBANL CSECT                                                                  
         SPACE 2                                                                
         EJECT                                                                  
         SPACE 2                                                                
*                                                                               
* ====================================================================          
* =             End of program                                       =          
* ====================================================================          
*                                                                               
         SPACE 2                                                                
         END   RAHWBANL                                                         
